;=======74HC165.ASM=================================4/25/97==
        list    p=16c84
        radix   hex
;------------------------------------------------------------
;       cpu equates (memory map)
porta	equ	0x05
portb   equ     0x06
status	equ	0x03
rcvreg	equ	0x0c
count	equ	0x0d
temp	equ	0x0e
trisa	equ	0x85
trisb	equ	0x86
;------------------------------------------------------------
;	bit equates
rp0	equ	5
;------------------------------------------------------------
        org     0x000
;
start   bsf     status,rp0  ;switch to bank 1
	movlw	b'00000001' ;bit 0 = input
        movwf   trisa
	movlw	b'00000000' ;outputs
	movwf	trisb
	bcf	status,rp0  ;switch back to bank 0
	movlw	0x04	;0000 0100
	movwf	porta	;control word
	call	ser_in	;to serial input subroutine
	movf	rcvreg,w    ;get data
	movwf	portb	;display data via LEDs
circle  goto    circle  ;done
;------------------------------------------------------------
ser_in	clrf	rcvreg	;clear receive register
	movlw	0x08	;init 8 counter
	movwf	count
	bcf	porta,2	;load shift register
	bsf	porta,2
getbit	movf	porta,w ;read port A
	movwf	temp	;store copy
	rrf	temp,f	;rotate bit into carry flag
	rlf	rcvreg,f    ;rotate carry flag into rcvreg
	decfsz	count,f	;decrement counter
	goto	shift
	return		;done
shift	bsf	porta,1	;shift 1 bit
	bcf	porta,1
	goto	getbit	;again
;------------------------------------------------------------
        end
;------------------------------------------------------------
;note: the 74HC165 gets shifted 7 times
;------------------------------------------------------------
;at blast time, select:
;       memory unprotected
;       watchdog timer disabled (default is enabled)
;       standard crystal (using 4 MHz osc for test) XT
;       power-up timer on
;============================================================
