;=======ADC0831.ASM=================================5/27/97==
        list    p=16c84
        radix   hex
;------------------------------------------------------------
;       cpu equates (memory map)
porta	equ	0x05
portb   equ     0x06
status	equ	0x03
rcvreg	equ	0x0c
count	equ	0x0d
temp	equ	0x0e
ncount	equ	0x10
mcount	equ	0x11
trisa	equ	0x85
trisb	equ	0x86
;------------------------------------------------------------
;	bit equates
c	equ	0
z	equ	2
rp0	equ	5
;------------------------------------------------------------
        org     0x000
;
start   bsf     status,rp0  ;switch to bank 1
	movlw	b'00000001' ;bit 0 = input
        movwf   trisa
	movlw	b'00000000' ;outputs
	movwf	trisb
	bcf	status,rp0  ;switch back to bank 0
	movlw	0x04	;0000 0100
	movwf	porta	;initialize
	nop		;delay
convert bcf	porta,2	;T setup, CS low
	nop
	bsf	porta,1	;clock high
	nop		;delay
	bcf	porta,1	;clock low - start conversion
	nop		;delay
	bsf	porta,1	;clock high
	call	ser_in	;to serial input subroutine
	bsf	porta,1	;last clock pulse
	nop
	bcf	porta,1	;clock low
	nop
	bsf	porta,2	;CS high
	movf	rcvreg,w  ;get data
	movwf	portb	;display data via LEDS
	call    debounce   ;wait a while (200 milliseconds)
	goto	convert	;look at voltage again
;----------------------------------------------------------
ser_in	clrf	rcvreg	;clear receive register
	movlw	0x08	;init 8 counter
	movwf	count
getbit	bcf	porta,1	;clock low
	nop		;delay 1 instr cycle
	movf	porta,w ;read port A
	movwf	temp	;store copy
	rrf	temp,f	;rotate bit into carry flag
	rlf	rcvreg,f  ;rotate carry flag into rcvreg
	decfsz	count,f	;decrement counter
	goto	shift
	return		;done
shift	bsf	porta,1	;clock high
	goto	getbit	;again
;------------------------------------------------------------  
debounce movlw  0xff	;M
	movwf	mcount	;to M counter
loadn	movlw	0xff	;N
	movwf	ncount	;to N counter
decn	decfsz	ncount,f  ;decrement N
	goto	decn	;again
	decfsz	mcount,f  ;decrement M
	goto	loadn	;again
	return		;done
;------------------------------------------------------------
        end
;------------------------------------------------------------
;at blast time, select:
;       memory unprotected
;       watchdog timer disabled (default is enabled)
;       standard crystal (using 4 MHz osc for test) XT
;       power-up timer on
;============================================================

