;=======AOUTPWM.ASM===================================5/29/97==
        list    p=16c84
        radix   hex
;------------------------------------------------------------
;       cpu equates (memory map)
status	equ	0x03
porta	equ	0x05
portb   equ     0x06
duty	equ	0x0c
response  equ	0x0d
count	equ	0x0e
trisa	equ	0x85
trisb	equ	0x86
;------------------------------------------------------------
;	bit equates
z	equ	2
rp0	equ	5
;------------------------------------------------------------
        org     0x000
;
start   bsf     status,rp0  ;switch to bank 1
	movlw	b'00000011' ;inputs/outputs
        movwf   trisa
	movlw	b'00000000' ;outputs
	movwf	trisb
	bcf	status,rp0  ;switch back to bank 0
	movlw	b'00000000' ;all outputs low
	movwf	portb
	movlw	0x7f	;initial duty cycle 50 percent
	movwf	duty
repeat1	movlw	0x30	;initial key response
	movwf	response
repeat2	call	pwm_per	;call PWM period subroutine
	decfsz	response   ;decrement/test button response
	goto	idle	;delay to make things even
	call	pressck	;look for incr/decr button press
	goto	repeat1
;------------------------------------------------------------
pressck	btfss	porta,1 ;decrease button pressed?
	goto	decduty	;yes, decrement duty cycle
	btfss	porta,0	;increase button pressed?
	goto	incduty	;yes, increment duty cycle
	nop
	nop
	nop
	goto	goback
incduty movf	duty,w	;get duty cycle into W
	sublw	0xff	;duty cycle=0xff?
	btfss	status,z
	incf	duty	;increment duty cycle
goback	return		;press check done
decduty	movf	duty,w	;get duty cycle into W
	sublw	0x00	;duty cycle=0?
	btfss	status,z
	decf	duty	;decrement duty cycle
	goto	goback
;------------------------------------------------------------
idle	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	goto	repeat2
;------------------------------------------------------------
pwm_per	movf	duty,w	;get duty cycle
	movwf	count
	sublw	0x00	;compare w/0
	btfsc	status,z
	goto	outlow
	bsf	portb,0	;output high
	movf	duty,w	;get duty cycle
	sublw	0xff	;compare w/0xff
	btfsc	status,z
	goto	del256
hi	decfsz	count,f	;high time
	goto	hi
	bcf	portb,0	;output low
	movf	duty,w	;get duty cycle
	sublw	0xff
	movwf	count	;low time
lo	decfsz	count,f
	goto	lo
	return
;------------------------------------------------------------
outlow	bcf	portb,0	;output low
del256	movlw	0xff	;delay full period
	movwf	count
loop	decfsz	count,f
	goto	loop
	return	
;------------------------------------------------------------	
        end
;------------------------------------------------------------
;at blast time, select:
;       memory unprotected
;       watchdog timer disabled (default is enabled)
;       standard crystal (using 4 MHz osc for test) XT
;       power-up timer on
;============================================================
