;=======DECENTRY.ASM================================10/6/98==
        list    p=16f84
        radix   hex
;------------------------------------------------------------
;       cpu equates (memory map)
tmr0	equ	0x01
status	equ	0x03
porta   equ     0x05
portb	equ	0x06
intcon	equ	0x0b
sendreg	equ	0x0c
count	equ	0x0d
instr	equ	0x0e
char	equ	0x0f
addr	equ	0x10
digctr	equ	0x11
rowctr	equ	0x12
colctr	equ	0x13
rowbits	equ	0x14
colbits	equ	0x15
temp	equ	0x16
ncount	equ	0x17
mcount	equ	0x18
test_n	equ	0x19
math	equ	0x1a
copy_8xn equ	0x1b
numsum	equ	0x1c
hund	equ	0x1d
ten	equ	0x1e
hold	equ	0x1f
flags	equ	0x20
optreg	equ	0x81
trisa	equ	0x85
trisb	equ	0x86
;------------------------------------------------------------
;	bit equates
c	equ	0
z	equ	2
rp0	equ	5
;------------------------------------------------------------
        org     0x000
;
start   bsf     status,rp0 ;switch to bank 1
	movlw	b'00000000' ;port A outputs
        movwf   trisa
	movlw	b'01110000' ;port B inputs/outputs
	movwf	trisb
	bcf	status,rp0 ;switch back to bank 0
	bsf	porta,1	;output mark, bit 1 (serial - LCD)
	bsf	portb,0	;rows high
	bsf	portb,1
	bsf	portb,2
	bsf	portb,3
	bcf	portb,7	;unused line low
	call	debounce
	call	debounce
	movlw	0x00	;blanks to display RAM
	movwf	instr
	call	sndstf	;send instruction to LCD module
	call	debounce
	movlw	0x01	;send 16 characters to display
	movwf	instr
	call	sndstf	;send instruction to LCD module
	call	debounce
	clrf	numsum	;clean out
	clrf	flags
do100	call	scan10
	movf	digctr,w   ;get 100's digit
	movwf	hund	;save copy
	sublw	0x00	;compare - digit=0?
	btfsc	status,z
	goto	hzero	;yes
	bsf	flags,0	;no this is ms digit
	movf	hund,w
	call	decx10	;times 10
	call	decx10	;times 10, result = x100
	addwf	numsum,f   ;add 100's to num sum register
	movf	hund,w	;get 100's digit
	call	hex2asc	;convert binary digit to ascii
	movwf	char
	movlw	0x20	;display RAM address
	movwf	addr
	movlw	0x03	;ascii char follows, send to display RAM
	movwf	instr
	call	sndstf	;send 100's digit to display RAM
	call	debounce   ;time delay - debounce switches
do10	call	scan10
	movf	digctr,w   ;get 10's digit
	movwf	ten	;save copy
	sublw	0x00	;compare - digit=0?
	btfsc	status,z
	goto	tzero	;yes
	movf	ten,w
	call	decx10	;times 10
	addwf	numsum,f   ;add 10's to num sum register
	movf	ten,w	;get 10's digit
	call	hex2asc	;convert binary digit to ascii
	movwf	char
	movlw	0x21	;display RAM address
	movwf	addr
	movlw	0x03	;ascii char follows, send to display RAM
	movwf	instr
	call	sndstf	;send 10's digit to display RAM
	call	debounce   ;time delay - debounce switches
do1	call	scan10
	movf	digctr,w   ;get 1's digit
	addwf	numsum,f   ;add 1's to num sum register
	call	hex2asc	;convert binary digit to ascii
	movwf	char
	movlw	0x22	;display RAM address
	movwf	addr
	movlw	0x03	;ascii char follows, send to display RAM
	movwf	instr
	call	sndstf	;send 1's digit to display RAM
	call	debounce
send	movlw	0x01	;send 16 characters to display
	movwf	instr
	call	sndstf	;to LCD module
	call	debounce
;display numsum contents
	movf	numsum,w   ;get total
	movwf	char
	movlw	0x04	;hex byte follows, convert and display
	movwf	instr
	call	sndstf
circle	goto	circle	;done
;------------------------------------------------------------
hzero	movlw	0x20	;ascii blank
	movwf	char
	movlw	0x20	;display RAM address
	movwf	addr
	movlw	0x03	;ascii character to display RAM
	movwf	instr
	call	sndstf
	call	debounce
	goto	do10
;------------------------------------------------------------
tzero	btfsc	flags,0	;ms digit entered?
	goto	zerot	;yes
	movlw	0x20	;ascii blank
tchar	movwf	char
	movlw	0x21	;display RAM address
	movwf	addr
	movlw	0x03	;ascii character to display RAM
	movwf	instr
	call	sndstf
	call	debounce
	goto	do1
zerot	movlw	0x30	;ascii 0
	goto	tchar
;------------------------------------------------------------
;returns with digit in digctr
;
scan10	bsf	portb,0	;rows high
	bsf	portb,1
	bsf	portb,2
	bsf	portb,3
	clrf	digctr	;digit counter=0
	bcf	portb,3	;row=4
	btfss	portb,5	;test column 2
	return		;"0" key press
	bsf	portb,3	;deselect row 4
	movlw	0x01
	movwf	digctr  ;digit counter=1
	movwf	rowctr  ;row counter=1
	movwf	rowbits	;row bits = 0000 0001
rowout	movf	rowbits,w  ;get row bits
	xorlw	0x0f	;complement row bits
	movwf	portb	;output row bits
	movlw	0x01
	movwf	colctr  ;column counter=1
	movlw	0x10	;0001 0000
	movwf	colbits ;col=1
tstcol	movf	portb,w	;read port B
	andlw	0x70	;mask off rows and bit 7
	movwf	temp	;columns
	movf	colbits,w  ;get column bits
	xorlw	0x70	;complement column bits
	subwf	temp,w	;compare with contents of temp
	btfsc	status,z
	return		;digit available
lastc	movf	colctr,w   ;get column count
	sublw	0x03
	btfsc	status,z   ;=3 ?
	goto	lastr
	rlf	colbits,f  ;shift column bits
	bcf	colbits,0  ;fix carry flag garbage
	incf	colctr,f
	incf	digctr,f
	goto	tstcol
lastr	movf	rowctr,w   ;get row count
	sublw	0x03
	btfsc	status,z   ;=3 ?
	goto	scan10	;scan 10 digit keys again
	rlf	rowbits,f  ;shift row bits
	bcf	rowbits,0  ;fix carry flag garbage
	incf	rowctr,f
	incf	digctr,f
	goto	rowout
;------------------------------------------------------------
debounce movlw	0x02	;to counter
	movwf	count  
dbloop  movlw   0xff	;M
	movwf	mcount	;to M counter
loadn	movlw	0xff	;N
	movwf	ncount	;to N counter
decn	decfsz	ncount,f   ;decrement N
	goto	decn	;again
	decfsz	mcount,f   ;decrement M
	goto	loadn	;again
	decfsz	count
	goto	dbloop	;thru loop within a loop twice -
;			    400 milliseconds
	return		;done
;------------------------------------------------------------
sndstf	movf	instr,w	;get instruction
	movwf	sendreg	;to be sent	
	call	ser_out	;to serial out subroutine
	movf	char,w	;get character or hex byte
	movwf	sendreg	;to be sent	
	call	ser_out	;to serial out subroutine
	movf	addr,w	;get address
	movwf	sendreg	;to be sent	
	call	ser_out	;to serial out subroutine
	return
;------------------------------------------------------------
ser_out	bcf	intcon,5   ;disable tmr0 interrupts
	bcf	intcon,7   ;disable global interrupts
	clrf	tmr0	;clear timer/counter
	clrwdt		;clear wdt prep prescaler assign
	bsf	status,rp0   ;to page 1
	movlw	b'11011000'  ;set up timer/counter
	movwf	optreg
	bcf	status,rp0   ;back to page 0
	movlw	0x08	;init shift counter
	movwf	count	
	bcf	porta,1	;start bit
	clrf	tmr0	;start timer/counter
	bcf	intcon,2   ;clear tmr0 overflow flag
time1	btfss	intcon,2   ;timer overflow?
	goto	time1	;no
	bcf	intcon,2   ;yes, clear overflow flag
nxtbit	rlf	sendreg,f  ;rotate msb into carry flag
	bcf	porta,1	;clear port A, bit 1
	btfsc	status,c   ;test carry flag
	bsf	porta,1 ;bit is set
time2	btfss	intcon,2   ;timer overflow?
	goto	time2	;no
	bcf	intcon,2   ;clear overflow flag
	decfsz	count,f	;shifted 8?
	goto	nxtbit	;no
	bsf	porta,1	;yes, output mark
time3	btfss	intcon,2   ;timer overflow?
	goto	time3	;no
	return		;done
;--------------------------------------------------------------------
;enter sub with number in w - exit with result in w
;
decx10	movwf	test_n    ;save copy of test number
	movwf	math	  ;working register
	bcf	status,c  ;clear carry flag
	rlf	math,f    ;x2
	bcf	status,c  ;clear carry flag
	rlf	math,f    ;x2
	bcf	status,c  ;clear carry flag
	rlf	math,f    ;x2
	movf	math,w    ;get copy of 8xn
	movwf	copy_8xn  ;store copy of 8xn
	movf	test_n,w  ;get copy of n
	movwf	math
	bcf	status,c  ;clear carry flag
	rlf	math,f	  ;x2
	movf	math,w	  ;get copy of 2n
	addwf	copy_8xn,w ;add 2n and 8n
	return		  ;result in w
;------------------------------------------------------------
;enter with hex digit in w
;
hex2asc	movwf	hold	;store copy of hex digit
	sublw	0x09	;subtract w from 1 less than 0x0a
	btfss	status,c   ;carry flag set if w < 0x0a
	goto	add37
	goto	add30
add37	movf	hold,w	;get hex digit
	addlw	0x37
	return		;return with ascii in w
add30	movf	hold,w	;get hex digit
	addlw	0x30
	return		;return with ascii in w		
;------------------------------------------------------------
        end
;------------------------------------------------------------
;at blast time, select:
;       memory unprotected
;       watchdog timer disabled (default is enabled)
;       standard crystal (using 4 MHz osc for test) XT
;       power-up timer on
;============================================================









