;=======EEPROM.ASM==================================6/10/97==
        list    p=16c84
        radix   hex
;------------------------------------------------------------
;       cpu equates (memory map)
status	equ	0x03
portb   equ     0x06
eedata	equ	0x08
eeadr	equ	0x09
address	equ	0x0c
byte	equ	0x0d
trisb	equ	0x86
eecon1	equ	0x88
eecon2	equ	0x89
;------------------------------------------------------------
;	bit equates
rd	equ	0
wr	equ	1
wren	equ	2
rp0	equ	5
;------------------------------------------------------------
        org     0x000
;
start   bsf     status,rp0  ;switch to bank 1
	movlw	b'00000000' ;outputs
	movwf	trisb
	bcf	status,rp0  ;switch back to bank 0
	clrf	portb	;initialize, LEDs off
	movlw	0x0f	;test data
	movwf	byte
	movlw	0x00	;test address
	movwf	address
	call	write	;write test byte to data EEPROM
	bsf	status,rp0  ;to bank 1
wrcompl	btfsc	eecon1,wr   ;test write complete?
	goto	wrcompl
	bcf	status,rp0  ;back to bank 0
	call	read	;read test byte from data EEPROM
	movwf	portb	;display test byte via LEDs
circle	goto	circle
;------------------------------------------------------------
read	movf	address,w   ;get address
	movwf	eeadr	;address to register
	bsf	status,rp0  ;bank 1
	bsf	eecon1,rd    ;read data EEPROM (RD bit will
;			        be cleared in hardware)
	bcf	status,rp0   ;return to bank 0
	movf	eedata,w    ;data into W
	return		;return with data in W
;------------------------------------------------------------
write	movf	address,w   ;get address
	movwf	eeadr	;address to register
	movf	byte,w	;get data
	movwf	eedata  ;data to register
	bsf	status,rp0  ;to bank 1
	bsf	eecon1,wren ;enable write
	movlw	0x55	;define 0x55 (per data book)
	movwf	eecon2	;to register
	movlw	0xaa	;define 0xaa (per data book)
	movwf	eecon2	;to register
	bsf	eecon1,wr   ;set WR bit to trigger write
	bcf	eecon1,wren ;disable write (won't effect
;				this one)
	bcf	status,rp0  ;back to bank 0
	return
;------------------------------------------------------------
        end
;------------------------------------------------------------
;at blast time, select:
;       memory unprotected
;       watchdog timer disabled (default is enabled)
;       standard crystal (using 4 MHz osc for test) XT
;       power-up timer on
;============================================================

