;=======LCDMSTR.ASM=================================5/19/97==
        list    p=16c84
        radix   hex
;------------------------------------------------------------
;       cpu equates (memory map)
tmr0	equ	0x01
status	equ	0x03
porta   equ     0x05
intcon	equ	0x0b
sendreg	equ	0x0c
count	equ	0x0d
instr	equ	0x0e
char	equ	0x0f
addr	equ	0x10
count1	equ	0x11
optreg	equ	0x81
trisa	equ	0x85
;------------------------------------------------------------
;	bit equates
c	equ	0
rp0	equ	5
;------------------------------------------------------------
;note: power-on with switch off
;------------------------------------------------------------
        org     0x000
;
start   bsf     status,rp0  ;switch to bank 1
	movlw	b'00000100' ;port A inputs/outputs
        movwf   trisa
	bcf	status,rp0  ;switch back to bank 0
	bsf	porta,1	;output mark, bit 1
switch	btfsc	porta,2	;start send?
	goto	switch	;not yet
;display "TEST"
	movlw	0x02	;display "test"
	movwf	instr
	call	sndstf	;call send stuff
;long delay required here if other tasks follow
circle  goto    circle  ;done
;------------------------------------------------------------
sndstf	movf	instr,w	;get instruction
	movwf	sendreg	;to be sent	
	call	ser_out	;to serial out subroutine
	movf	char,w	;get character or hex byte
	movwf	sendreg	;to be sent	
	call	ser_out	;to serial out subroutine
	movf	addr,w	;get address
	movwf	sendreg	;to be sent	
	call	ser_out	;to serial out subroutine
	return
;------------------------------------------------------------
ser_out	bcf	intcon,5   ;disable tmr0 interrupts
	bcf	intcon,7   ;disable global interrupts
	clrf	tmr0	;clear timer/counter
	clrwdt		;clear wdt prep prescaler assign
	bsf	status,rp0   ;to page 1
	movlw	b'11011000'  ;set up timer/counter
	movwf	optreg
	bcf	status,rp0   ;back to page 0
	movlw	0x08	;init shift counter
	movwf	count	
	bcf	porta,1	;start bit
	clrf	tmr0	;start timer/counter
	bcf	intcon,2   ;clear tmr0 overflow flag
time1	btfss	intcon,2   ;timer overflow?
	goto	time1	;no
	bcf	intcon,2   ;yes, clear overflow flag
nxtbit	rlf	sendreg,f  ;rotate msb into carry flag
	bcf	porta,1	;clear port A, bit 1
	btfsc	status,c   ;test carry flag
	bsf	porta,1 ;bit is set
time2	btfss	intcon,2   ;timer overflow?
	goto	time2	;no
	bcf	intcon,2   ;clear overflow flag
	decfsz	count,f	;shifted 8?
	goto	nxtbit	;no
	bsf	porta,1	;yes, output mark
time3	btfss	intcon,2   ;timer overflow?
	goto	time3	;no
	return		;done
;------------------------------------------------------------
del_125	movlw	0x2a	;approx 42x3 cycles (decimal)
	movwf	count1	;load counter
repeat	decfsz	count1,f   ;decrement counter
	goto	repeat	;not 0
	return		;counter 0, ends delay		
;------------------------------------------------------------
        end
;------------------------------------------------------------
;at blast time, select:
;       memory unprotected
;       watchdog timer disabled (default is enabled)
;       standard crystal (using 4 MHz osc for test) XT
;       power-up timer on
;============================================================


;send blanks to display RAM
	movlw	0x00	;blanks to display RAM
	movwf	instr
	call	sndstf	;call send stuff
	call	del_125	;wait for slave to fill w/blanks
	movlw	0x01	;send 16 characters to display
	movwf	instr
	call	sndstf	;call send stuff

;display "A" followed by blanks
	movlw	0x00	;blanks to display RAM
	movwf	instr
	call	sndstf	;call send stuff
	call	del_125	;wait for slave to do it's thing
	movlw	0x03	;ascii character follows
	movwf	instr
	movlw	"A"	;define ascii "A"
	movwf	char
	movlw	0x20	;first display RAM address
	movwf	addr
	call	sndstf	;call send stuff
	movlw	0x01	;send 16 characters to display
	movwf	instr
	call	sndstf	;call send stuff

;display hex byte
	movlw	0x04	;hex byte follows
	movwf	instr
	movlw	0x01	;define hex byte 0x__
	movwf	char
	call	sndstf	;call send stuff



