;=======LCDTST.ASM=====================================5/5/97==
        list    p=16c84
        radix   hex
;------------------------------------------------------------
;       cpu equates (memory map)
status	equ	0x03
porta	equ	0x05
portb   equ     0x06
count1	equ	0x0c
count2	equ	0c0d
trisa	equ	0x85
trisb	equ	0x86
;------------------------------------------------------------
;	bit equates
rp0	equ	5
;------------------------------------------------------------
        org     0x000
;
start   bsf     status,rp0  ;switch to bank 1
	movlw	b'00000000' ;outputs
        movwf   trisa
	movwf	trisb
	bcf	status,rp0  ;switch back to bank 0
	movlw	b'00000000' ;all outputs low
	movwf	porta
	movwf	portb
	call	del_5	;allow lcd time to initialize itself
	call	initlcd	;initialize display
circle  goto    circle  ;done
;------------------------------------------------------------
initlcd bcf	porta,1	;E line low
	bcf	porta,2	;RS line low, set up for control
	call	del_125	;delay 125 microseconds
	movlw	0x38	;8-bit, 5X7
	movwf	portb	;0011 1000
	call	pulse	;pulse and delay
	movlw	0x0f	;display on, cursor blinking
	movwf	portb	;0000 1111
	call	pulse
	movlw	0x01	;clear display
	movwf	portb	;0000 0001
	call	pulse
	call	del_5	;delay 5 milliseconds after init
	return
;------------------------------------------------------------
del_125	movlw	0x2a	;approx 42x3 cycles (decimal)
	movwf	count1	;load counter
repeat	decfsz	count1,f   ;decrement counter
	goto	repeat	;not 0
	return		;counter 0, ends delay	
;------------------------------------------------------------
del_5	movlw	0x29	;decimal 40
	movwf	count2	;to counter
delay	call	del_125	;delay 125 microseconds
	decfsz	count2,f   ;do it 40 times = 5 milliseconds
	goto	delay
	return		;counter 0, ends delay
;------------------------------------------------------------
pulse	bsf	porta,1	;pulse E line
	nop		;delay
	bcf	porta,1
	call	del_125	;delay 125 microseconds
	return
;------------------------------------------------------------	
        end
;------------------------------------------------------------
;at blast time, select:
;       memory unprotected
;       watchdog timer disabled (default is enabled)
;       standard crystal (using 4 MHz osc for test) XT
;       power-up timer on
;============================================================
