;=======LCDTST4.ASM=================================5/26/97==
        list    p=16c84
        radix   hex
;------------------------------------------------------------
;       cpu equates (memory map)
status	equ	0x03
porta	equ	0x05
portb   equ     0x06
count1	equ	0x0c
count2	equ	0x0d
bits	equ	0x0e
trisa	equ	0x85
trisb	equ	0x86
;------------------------------------------------------------
;	bit equates
rp0	equ	5
;------------------------------------------------------------
        org     0x000
;
start   bsf     status,rp0  ;switch to bank 1
	movlw	b'00000000' ;outputs
        movwf   trisa
	movwf	trisb
	bcf	status,rp0  ;switch back to bank 0
	movlw	b'00000000' ;all outputs low
	movwf	porta
	movwf	portb
	call	del_5	;allow lcd time to initialize itself
	call	initlcd	;initialize display
	call	display	;send 'A' character
circle  goto    circle  ;done
;------------------------------------------------------------
display	bcf	porta,1	;E line low
	bcf	porta,2	;RS line low, set up for control
	call	del_125	;delay 125 microseconds
	movlw	0x80	;control word = address first half
	call	send
	bsf	porta,2	;RS=1, set up for data
	call	del_125	;delay 125 microseconds
	movlw	'A'	;define character
	call	send
	return
;------------------------------------------------------------
initlcd bcf	porta,1	;E line low
	bcf	porta,2	;RS line low, set up for control
	call	del_125	;delay 125 microseconds
	movlw	0x38	;8-bit, 5X7 mode
	movwf	bits	;0011 1000
	call	flipbit	;output 4 MS bits (LS not used)
	call	pulse	;send bits
	call	del_125	;delay
	movlw	0x28	;4-bit, 5x7 mode
	movwf	bits	;0010 1000
	call	flipbit	;output 4 MS bits (LS not used)
	call	pulse	;get into 4-bit mode
	call	del_125
	movlw	0x28	;4-bit, 5x7 mode
	call	send	;send both nybbles
	movlw	0x0f	;display on, cursor blinking
	call	send
	movlw	0x01	;clear display
	call	send
	call	del_5	;delay 5 milliseconds
	return
;------------------------------------------------------------
send	movwf	bits
	call	flipbit
	call	pulse
	swapf	bits,f	;swap MS and LS nybbles
	call	flipbit	;output what was LS nybble
	call	pulse
	call	del_125
	return
;------------------------------------------------------------

flipbit	bcf	portb,4	;default
	btfsc	bits,4	;test bit in "bits"
	bsf	portb,4	;bit in "bits" set
	bcf	portb,5
	btfsc	bits,5
	bsf	portb,5
	bcf	portb,6
	btfsc	bits,6
	bsf	portb,6
	bcf	portb,7
	btfsc	bits,7
	bsf	portb,7
	return
;------------------------------------------------------------
del_125	movlw	0x2a	;approx 42x3 cycles (decimal)
	movwf	count1	;load counter
repeat	decfsz	count1,f   ;decrement counter
	goto	repeat	;not 0
	return		;counter 0, ends delay	
;------------------------------------------------------------
del_5	movlw	0x29	;decimal 40
	movwf	count2	;to counter
delay	call	del_125	;delay 125 microseconds
	decfsz	count2,f   ;do it 40 times = 5 milliseconds
	goto	delay
	return		;counter 0, ends delay
;------------------------------------------------------------
pulse	bsf	porta,1	;pulse E line
	nop		;delay
	bcf	porta,1
	return
;------------------------------------------------------------	
        end
;------------------------------------------------------------
;at blast time, select:
;       memory unprotected
;       watchdog timer disabled (default is enabled)
;       standard crystal (using 4 MHz osc for test) XT
;       power-up timer on
;============================================================
