;=======RCTIME.ASM===================================6/6/97==
        list    p=16c84
        radix   hex
;------------------------------------------------------------
;       cpu equates (memory map)
tmr0	equ	0x01
status	equ	0x03
porta	equ	0x05
portb   equ     0x06
intcon	equ	0x0b
opt	equ	0x81
trisa	equ	0x85
trisb	equ	0x86
;------------------------------------------------------------
;	bit equates
rp0	equ	5
;------------------------------------------------------------
        org     0x000
	goto	start	;skip over location pointed to by
			;   interrupt vector
	org	0x004
	goto	iserv
;------------------------------------------------------------
start   bsf     status,rp0  ;switch to bank 1
	movlw	b'00000000'  ;outputs
        movwf   trisa
	movwf	trisb
	bcf	status,rp0  ;switch back to bank 0
	clrf	portb	;LEDs off
	bcf	intcon,2    ;clear TMR0 interrupt flag
	bsf	intcon,7    ;enable global interrupts
	bsf	intcon,5    ;enable TMR0 interrupts
	clrwdt		;clear WDT prep prescale assign
	bsf	status,rp0  ;switch to bank 1
	movlw	b'11010001' ;select TMR0, internal
;			        clock source, prescale 4
	movwf	opt
	bcf	status,rp0  ;return to bank 0
	bcf	porta,0	;discharge cap
	clrf	tmr0	;start timer, known state
dischg	btfss	tmr0,7	;time for cap discharge
	goto	dischg
	bsf     status,rp0  ;switch to bank 1
	bsf	trisa,0	;porta, bit 0 input
	bcf	status,rp0  ;switch back to bank 0
	clrf	tmr0	;start TMR0
flip	btfss	porta,0	;look at input
	goto	flip	;input low
	movf	tmr0,w	;input flipped,read timer
	movwf	portb	;display time at port B
	bcf	intcon,5    ;disable TMR0 interrupts
circle	goto	circle	;done
;------------------------------------------------------------
iserv	bcf	intcon,5    ;disable further TMR0 interrupts
	movlw	0xaa
	movwf	portb	;display timer overflow condition
idle	goto	idle

;------------------------------------------------------------	
        end
;------------------------------------------------------------
;at blast time, select:
;       memory unprotected
;       watchdog timer disabled (default is enabled)
;       standard crystal (using 4 MHz osc for test) XT
;       power-up timer on
;============================================================

