;=======SCANPAD.ASM=================================5/20/97==
        list    p=16c84
        radix   hex
;------------------------------------------------------------
;       cpu equates (memory map)
tmr0	equ	0x01
status	equ	0x03
porta   equ     0x05
portb	equ	0x06
intcon	equ	0x0b
sendreg	equ	0x0c
count	equ	0x0d
instr	equ	0x0e
char	equ	0x0f
addr	equ	0x10
count1	equ	0x11
digctr	equ	0x12
rowctr	equ	0x13
colctr	equ	0x14
rowbits	equ	0x15
colbits	equ	0x16
temp	equ	0x17
ncount	equ	0x18
mcount	equ	0x19
optreg	equ	0x81
trisa	equ	0x85
trisb	equ	0x86
;------------------------------------------------------------
;	bit equates
c	equ	0
z	equ	2
rp0	equ	5
;------------------------------------------------------------
        org     0x000
;
start   bsf     status,rp0 ;switch to bank 1
	movlw	b'00000000' ;port A outputs
        movwf   trisa
	movlw	b'01110000' ;port B inputs/outputs
	movwf	trisb
	bcf	status,rp0 ;switch back to bank 0
	bsf	porta,1	;output mark, bit 1 (serial - LCD)
	bsf	portb,0	;rows high
	bsf	portb,1
	bsf	portb,2
	bsf	portb,3
	bcf	portb,7	;unused line low
ckpad	call	scan10
	movlw	0x04	;hex byte follows
	movwf	instr
	movf	digctr,w   ;get digit
	movwf	char
	call	sndstf	;call send stuff
	call	debounce   ;time delay - debounce switches
	goto	ckpad	;repeat
;------------------------------------------------------------
scan10	bsf	portb,0	;rows high
	bsf	portb,1
	bsf	portb,2
	bsf	portb,3
	clrf	digctr	;digit counter=0
	bcf	portb,3	;row=4
	btfss	portb,5	;test column 2
	return		;"0" key press
	bsf	portb,3	;deselect row 4
	movlw	0x01
	movwf	digctr  ;digit counter=1
	movwf	rowctr  ;row counter=1
	movwf	rowbits	;row bits = 0000 0001
rowout	movf	rowbits,w  ;get row bits
	xorlw	0x0f	;complement row bits
	movwf	portb	;output row bits
	movlw	0x01
	movwf	colctr  ;column counter=1
	movlw	0x10	;0001 0000
	movwf	colbits ;col=1
tstcol	movf	portb,w	;read port B
	andlw	0x70	;mask off rows and bit 7
	movwf	temp	;columns
	movf	colbits,w  ;get column bits
	xorlw	0x70	;complement column bits
	subwf	temp,w	;compare with contents of temp
	btfsc	status,z
	return		;digit available
lastc	movf	colctr,w   ;get column count
	sublw	0x03
	btfsc	status,z   ;=3 ?
	goto	lastr
	rlf	colbits,f  ;shift column bits
	bcf	colbits,0  ;fix carry flag garbage
	incf	colctr,f
	incf	digctr,f
	goto	tstcol
lastr	movf	rowctr,w   ;get row count
	sublw	0x03
	btfsc	status,z   ;=3 ?
	goto	scan10	;scan 10 digit keys again
	rlf	rowbits,f  ;shift row bits
	bcf	rowbits,0  ;fix carry flag garbage
	incf	rowctr,f
	incf	digctr,f
	goto	rowout
;------------------------------------------------------------  
debounce movlw  0xff	;M
	movwf	mcount	;to M counter
loadn	movlw	0xff	;N
	movwf	ncount	;to N counter
decn	decfsz	ncount,f   ;decrement N
	goto	decn	;again
	decfsz	mcount,f   ;decrement M
	goto	loadn	;again
	return		;done
;------------------------------------------------------------
sndstf	movf	instr,w	;get instruction
	movwf	sendreg	;to be sent	
	call	ser_out	;to serial out subroutine
	movf	char,w	;get character or hex byte
	movwf	sendreg	;to be sent	
	call	ser_out	;to serial out subroutine
	movf	addr,w	;get address
	movwf	sendreg	;to be sent	
	call	ser_out	;to serial out subroutine
	return
;------------------------------------------------------------
ser_out	bcf	intcon,5   ;disable tmr0 interrupts
	bcf	intcon,7   ;disable global interrupts
	clrf	tmr0	;clear timer/counter
	clrwdt		;clear wdt prep prescaler assign
	bsf	status,rp0   ;to page 1
	movlw	b'11011000'  ;set up timer/counter
	movwf	optreg
	bcf	status,rp0   ;back to page 0
	movlw	0x08	;init shift counter
	movwf	count	
	bcf	porta,1	;start bit
	clrf	tmr0	;start timer/counter
	bcf	intcon,2   ;clear tmr0 overflow flag
time1	btfss	intcon,2   ;timer overflow?
	goto	time1	;no
	bcf	intcon,2   ;yes, clear overflow flag
nxtbit	rlf	sendreg,f  ;rotate msb into carry flag
	bcf	porta,1	;clear port A, bit 1
	btfsc	status,c   ;test carry flag
	bsf	porta,1 ;bit is set
time2	btfss	intcon,2   ;timer overflow?
	goto	time2	;no
	bcf	intcon,2   ;clear overflow flag
	decfsz	count,f	;shifted 8?
	goto	nxtbit	;no
	bsf	porta,1	;yes, output mark
time3	btfss	intcon,2   ;timer overflow?
	goto	time3	;no
	return		;done	
;------------------------------------------------------------
        end
;------------------------------------------------------------
;at blast time, select:
;       memory unprotected
;       watchdog timer disabled (default is enabled)
;       standard crystal (using 4 MHz osc for test) XT
;       power-up timer on
;============================================================







