;=======SINE.ASM=====================================6/3/97==
        list    p=16c84
        radix   hex
;------------------------------------------------------------
;       cpu equates (memory map)
pc	equ	0x02
status	equ	0x03
porta   equ     0x05
sendreg	equ	0x0c
count	equ	0x0d
control	equ	0x0e
volts	equ	0x0f
count1	equ	0x10
offctr	equ	0x11
trisa	equ	0x85
;------------------------------------------------------------
;	bit equates
z	equ	2
rp0	equ	5
;------------------------------------------------------------
        org     0x000
;
start	goto	do_it	;jump over table
;------------------------------------------------------------
table	addwf	pc,f	;add offset to program counter
	retlw	0x80	;2.50 volts
	retlw	0x95	;2.94
	retlw	0xad	;3.36
	retlw	0xc1	;3.75
	retlw	0xd3	;4.11
	retlw	0xe2	;4.41
	retlw	0xef	;4.67
	retlw	0xf8	;4.85
	retlw	0xfd	;4.96
	retlw	0xff	;4.98
	retlw	0xfd	;4.96
	retlw	0xf8	;4.85
	retlw	0xef	;4.67
	retlw	0xe2	;4.41
	retlw	0xd3	;4.11
	retlw	0xc1	;3.75
	retlw	0xad	;3.36
	retlw	0x95	;2.94
	retlw	0x80	;2.50
	retlw	0x6a	;2.06
	retlw	0x54	;1.64
	retlw	0x40	;1.25
	retlw	0x2e	;0.90
	retlw	0x1e	;0.59
	retlw	0x11	;0.33
	retlw	0x08	;0.15
	retlw	0x02	;0.04
	retlw	0x00	;0.00
	retlw	0x02	;0.04
	retlw	0x08	;0.15
	retlw	0x11	;0.33
	retlw	0x1e	;0.59
	retlw	0x2e	;0.90
	retlw	0x40	;1.25
	retlw	0x54	;1.64
	retlw	0x6a	;2.06
;------------------------------------------------------------
do_it   bsf     status,rp0  ;switch to bank 1
	movlw	b'00000000' ;outputs
        movwf   trisa
	bcf	status,rp0  ;switch back to bank 0
	movlw	0x04	;0000 0100
	movwf	porta	;initialize port
	movlw	b'00110001' ;define control word
	movwf	control	;store - ready for sub
cycle	clrf	offctr	;clear table offset counter
step	movf	offctr,w    ;get offset count
	call	table	;get volts from table
	movwf	volts	;store in "volts"	
	call	sub1	;send volts to a/d
	call	del_10	;delay
	movf	offctr,w    ;get offset count
	sublw	0x23	;compare - cycle complete?
	btfsc	status,z
	goto	cycle
	incf	offctr	;increment offset counter
	goto	step
;------------------------------------------------------------
sub1	bcf	porta,2	;CS low - start serial comm process
	movf	control,w   ;get control word
	call	ser_out     ;to serial out subroutine
	movf	volts,w	;get data
	call	ser_out	;to serial out subroutine
	bsf	porta,2	;CS high - end serial comm process
	return
;------------------------------------------------------------
ser_out	movwf	sendreg	;save copy of byte
	movlw	0x08	;init 8 counter
	movwf	count
testbit	bcf	porta,0	;default
	btfsc	sendreg,7  ;test byte bit 7
	bsf	porta,0 ;bit is set
shift	bsf	porta,1	;shift register
	bcf	porta,1
rotlft	rlf	sendreg,f  ;shift byte left
	decfsz	count,f	;decrement bit counter
	goto	testbit	;next bit
	return		;done
;------------------------------------------------------------
del_10	movlw	0x03	;approx 9 cycles (decimal)
	movwf	count1	;load counter
repeat	decfsz	count1,f   ;decrement counter
	goto	repeat	;not 0
	return		;counter 0, ends delay
;------------------------------------------------------------
        end
;------------------------------------------------------------
;at blast time, select:
;       memory unprotected
;       watchdog timer disabled (default is enabled)
;       standard crystal (using 4 MHz osc for test) XT
;       power-up timer on
;============================================================
