;=======TEMPLCD.ASM=================================6/27/97==
        list    p=16c84
        radix   hex
;------------------------------------------------------------
;       cpu equates (memory map)
tmr0	equ	0x01
status	equ	0x03
porta   equ     0x05
intcon	equ	0x0b
sendreg	equ	0x0c
count	equ	0x0d
instr	equ	0x0e
char	equ	0x0f
addr	equ	0x10
number  equ     0x12
ncount	equ	0x15
mcount	equ	0x16
hold	equ	0x17
tenk	equ	0x20
onek	equ	0x21
hund	equ	0x22
tens	equ	0x25
ones	equ	0x26
tenths	equ	0x27	
optreg	equ	0x81
trisa	equ	0x85
;------------------------------------------------------------
;	bit equates
c	equ	0
z	equ	2
rp0	equ	5
;------------------------------------------------------------
        org     0x000
;
start   bsf     status,rp0 ;switch to bank 1
	movlw	b'00000000' ;port A outputs
        movwf   trisa
	bcf	status,rp0 ;switch back to bank 0
	bsf	porta,1	;output mark, bit 1 (serial - LCD)
	call	debounce
	call	debounce
	movlw	0x00	;blanks to display RAM
	movwf	instr
	call	sndstf	;send instruction to LCD module
	call	debounce
	movlw	0x01	;send 16 characters to display
	movwf	instr
	call	sndstf	;send instruction to LCD module
	call    debounce
setup	movlw	0x00	;test digits
	movwf	tenk
	movlw	0x05
	movwf	onek
	movlw	0x00
	movwf	hund	
	movf	tenk,w	;rename for easier comprehension
	movwf	tens	;from round off to display
	movf	onek,w
	movwf	ones
	movf	hund,w
	movwf	tenths
zcheck	movf	tens,w  ;get 10's digit
	sublw	0x00	;compare - digit=0?
	btfsc	status,z
	goto	tenzero	;yes
do10	movf	tens,w	;get 10's digit
	call	hex2asc	;convert binary digit to ascii
	movwf	char
	movlw	0x20	;display RAM address
	movwf	addr
	movlw	0x03	;ascii char follows, send to display RAM
	movwf	instr
	call	sndstf	;send 10's digit to display RAM
	call	debounce   ;time delay
do1	movf	ones,w	;get 1's digit
	call	hex2asc	;convert binary digit to ascii
	movwf	char
	movlw	0x21	;display RAM address
	movwf	addr
	movlw	0x03	;ascii char follows, send to display RAM
	movwf	instr
	call	sndstf	;send 1's digit to display RAM
	call	debounce   ;time delay
do10ths	movf	tenths,w   ;get 10ths digit
	call	hex2asc	;convert binary digit to ascii
	movwf	char
	movlw	0x23	;display RAM address
	movwf	addr
	movlw	0x03	;ascii char follows, send to display RAM
	movwf	instr
	call	sndstf	;send 10ths digit to display RAM
	call	debounce   ;time delay
decpt	movlw	0x2e	;ascii "period", decimal point
	movwf	char
	movlw	0x22	;display RAM address
	movwf	addr
	movlw	0x03	;ascii char follows, send to display RAM
	movwf	instr
	call	sndstf	;send decimal point to display RAM
	call	debounce   ;time delay
send	movlw	0x01	;send 16 characters to display
	movwf	instr
	call	sndstf	;to LCD module
circle	goto	circle	;done
;------------------------------------------------------------
tenzero	movlw	0x20	;ascii blank
	movwf	char
	movlw	0x20	;display RAM address
	movwf	addr
	movlw	0x03	;ascii character to display RAM
	movwf	instr
	call	sndstf
	call	debounce
	movf	ones,w   ;get 1's digit
	sublw	0x00	;compare - digit=0?
	btfss	status,z
	goto	do1	;if 0, fall thru to onezero	
;------------------------------------------------------------
onezero	movlw	0x20	;ascii blank
	movwf	char
	movlw	0x21	;display RAM address
	movwf	addr
	movlw	0x03	;ascii character to display RAM
	movwf	instr
	call	sndstf
	call	debounce
	goto	do10ths
;------------------------------------------------------------
debounce movlw	0x02	;to counter
	movwf	count  
dbloop  movlw   0xff	;M
	movwf	mcount	;to M counter
loadn	movlw	0xff	;N
	movwf	ncount	;to N counter
decn	decfsz	ncount,f   ;decrement N
	goto	decn	;again
	decfsz	mcount,f   ;decrement M
	goto	loadn	;again
	decfsz	count
	goto	dbloop	;thru loop within a loop twice -
;			    400 milliseconds
	return		;done
;------------------------------------------------------------
sndstf	movf	instr,w	;get instruction
	movwf	sendreg	;to be sent	
	call	ser_out	;to serial out subroutine
	movf	char,w	;get character or hex byte
	movwf	sendreg	;to be sent	
	call	ser_out	;to serial out subroutine
	movf	addr,w	;get address
	movwf	sendreg	;to be sent	
	call	ser_out	;to serial out subroutine
	return
;------------------------------------------------------------
ser_out	bcf	intcon,5   ;disable tmr0 interrupts
	bcf	intcon,7   ;disable global interrupts
	clrf	tmr0	;clear timer/counter
	clrwdt		;clear wdt prep prescaler assign
	bsf	status,rp0   ;to page 1
	movlw	b'11011000'  ;set up timer/counter
	movwf	optreg
	bcf	status,rp0   ;back to page 0
	movlw	0x08	;init shift counter
	movwf	count	
	bcf	porta,1	;start bit
	clrf	tmr0	;start timer/counter
	bcf	intcon,2   ;clear tmr0 overflow flag
time1	btfss	intcon,2   ;timer overflow?
	goto	time1	;no
	bcf	intcon,2   ;yes, clear overflow flag
nxtbit	rlf	sendreg,f  ;rotate msb into carry flag
	bcf	porta,1	;clear port A, bit 1
	btfsc	status,c   ;test carry flag
	bsf	porta,1 ;bit is set
time2	btfss	intcon,2   ;timer overflow?
	goto	time2	;no
	bcf	intcon,2   ;clear overflow flag
	decfsz	count,f	;shifted 8?
	goto	nxtbit	;no
	bsf	porta,1	;yes, output mark
time3	btfss	intcon,2   ;timer overflow?
	goto	time3	;no
	return		;done
;------------------------------------------------------------
;enter with hex digit in w
;
hex2asc	movwf	hold	;store copy of hex digit
	sublw	0x09	;subtract w from 1 less than 0x0a
	btfss	status,c   ;carry flag set if w < 0x0a
	goto	add37
	goto	add30
add37	movf	hold,w	;get hex digit
	addlw	0x37
	return		;return with ascii in w
add30	movf	hold,w	;get hex digit
	addlw	0x30
	return		;return with ascii in w		
;------------------------------------------------------------
        end
;------------------------------------------------------------
;at blast time, select:
;       memory unprotected
;       watchdog timer disabled (default is enabled)
;       standard crystal (using 4 MHz osc for test) XT
;       power-up timer on
;============================================================













