;=======THtlPWM.ASM==================================6/5/97==
        list    p=16c84
        radix   hex
;------------------------------------------------------------
;       cpu equates (memory map)
tmr0	equ	0x01
status	equ	0x03
porta	equ	0x05
portb   equ     0x06
intcon	equ	0x0b
duty	equ	0x0c
flags 	equ	0x0d
opt	equ	0x81
trisa	equ	0x85
trisb	equ	0x86
;------------------------------------------------------------
;	bit equates
c	equ	0
z	equ	2
rp0	equ	5
t	equ	0
;------------------------------------------------------------
        org     0x000
	goto	start	;skip over location pointed to by
			;   interrupt vector
	org	0x004
	goto	iserv
;------------------------------------------------------------
start   bsf     status,rp0  ;switch to bank 1
	movlw	b'00000010' ;inputs/outputs
        movwf   trisa
	movlw	b'11111111' ;inputs
	movwf	trisb
	bcf	status,rp0  ;switch back to bank 0
	bsf	porta,0	;output high
	bcf	intcon,2    ;clear TMR0 interrupt flag
	bsf	intcon,7    ;enable global interrupts
	bsf	intcon,5    ;enable TMR0 interrupts
	clrwdt		;clear WDT prep prescale assign
	bsf	status,rp0  ;switch to bank 1
	movlw	b'11010001' ;select TMR0, internal
;			        clock source, prescale 4
	movwf	opt
	bcf	status,rp0  ;return to bank 0
	clrf	tmr0	;start timer known state
	movlw	0x99	;initial duty cycle 60 percent
	movwf	duty
	movf	duty,w	;get duty cycle
	sublw	0xff	;complement
	movwf	tmr0	;start TMR0
circle	goto	circle	;wait for interrupt
;------------------------------------------------------------
iserv	bcf	intcon,2    ;clear TMR0 interrupt flag
	movf	duty,w	;get duty cycle
	sublw	0x00	;compare w/0x00
	btfsc	status,z
	goto	outlow
	movf	duty,w	;get duty cycle
	sublw	0xff	;compare w/0xff
	btfsc	status,z
	goto	outhi
	btfss	flags,t	;test TH/tl flag
	goto	do_th	;flag is clear
do_tl	bcf	porta,0	;output low
	bcf	flags,t	;flag is set, clear it
	movf	duty,w	;get duty = comp of tl
	nop		;equalize time for paths
	nop
	nop
load_t	movwf	tmr0	;start TMR0
	sublw	0x7f	;compare with 50 percent
	btfss	status,c
	retfie
switch	btfsc	porta,1	;check data ready switch
	retfie
	movf	portb,w	;switch pressed, read data
	movwf	duty	;store in duty cycle register
	retfie
;------------------------------------------------------------
do_th	bsf	porta,0	;output high
	bsf	flags,t ;TH/tl flag is clear, set it
	movf	duty,w	;get duty cycle
	sublw	0xff	;complement
	goto	load_t
;------------------------------------------------------------
outlow	bcf	porta,0	;output low
	clrf	tmr0	;start TMR0, 256
	goto	switch
;------------------------------------------------------------
outhi	bsf	porta,0	;output high
	clrf	tmr0	;start TMR0, 256
	goto	switch
;------------------------------------------------------------	
        end
;------------------------------------------------------------
;at blast time, select:
;       memory unprotected
;       watchdog timer disabled (default is enabled)
;       standard crystal (using 4 MHz osc for test) XT
;       power-up timer on
;============================================================

